「杂题乱刷」CF1979C

代码恢复训练 2024.6.7.

题目链接

CF1979C (codeforces)

CF1979C (luogu)

解题思路

我们发现,如果答案序列的和小于等于 \(x\) 时是合法的,那么容易得出答案序列的和小于等于 \(x + 1\) 时也是合法的。

因此我们发现答案序列的和的合法性是具有单调性的。

直接二分即可,答案中的每个数可以贪心 \(O(1)\) 求出。

总时间复杂度 \(O(n \log_2 V)\),其中 \(V\) 为答案上界,这里我取了 \(10^{12}\)

参考代码

点击查看代码
/*
Tips:
你数组开小了吗?
你MLE了吗?
你觉得是贪心,是不是该想想dp?
一个小时没调出来,是不是该考虑换题?
打 cf 不要用 umap!!!

记住,rating 是身外之物。

该冲正解时冲正解!

Problem:

算法:

思路:

*/
#include<bits/stdc++.h>
using namespace std;
//#define map unordered_map
#define forl(i,a,b) for(register long long i=a;i<=b;i++)
#define forr(i,a,b) for(register long long i=a;i>=b;i--)
#define forll(i,a,b,c) for(register long long i=a;i<=b;i+=c)
#define forrr(i,a,b,c) for(register long long i=a;i>=b;i-=c)
#define lc(x) x<<1
#define rc(x) x<<1|1
#define mid ((l+r)>>1)
#define cin(x) scanf("%lld",&x)
#define cout(x) printf("%lld",x)
#define lowbit(x) (x&-x)
#define pb push_back
#define pf push_front
#define IOS ios::sync_with_stdio(0),cin.tie(0),cout.tie(0);
#define endl '\n'
#define QwQ return 0;
#define ll long long
#define ull unsigned long long
#define lcm(x,y) x/__gcd(x,y)*y
#define Sum(x,y) 1ll*(x+y)*(y-x+1)/2
#define aty cout<<"Yes\n";
#define atn cout<<"No\n";
#define cfy cout<<"YES\n";
#define cfn cout<<"NO\n";
#define xxy cout<<"yes\n";
#define xxn cout<<"no\n";
#define printcf(x) x?cout<<"YES\n":cout<<"NO\n";
#define printat(x) x?cout<<"Yes\n":cout<<"No\n";
#define printxx(x) x?cout<<"yes\n":cout<<"no\n";
ll t;
ll n,a[100010],ans[100010];
bool check(ll Mid)//总共<=Mid 
{
	ll sum=0;
	forl(i,1,n)
	{
		ans[i]=ceil(1.0*Mid/a[i]);
		if(ans[i]<1)
			ans[i]=1;
		if(ans[i]>1e9)
			ans[i]=1e9;
		sum+=ans[i];
	}
	forl(i,1,n)
		if(sum>=ans[i]*a[i])
			return 0;
	return sum<=Mid;
}
void solve()
{
	cin>>n;
	forl(i,1,n)
		cin>>a[i];
	ll L=0,R=1e12;
	while(L<R)
	{
		ll Mid=(L+R+1)/2;
		if(check(Mid))
			L=Mid;
		else
			R=Mid-1; 
	}
	if(check(L))
	{
		forl(i,1,n)
			cout<<ans[i]<<' ';
		cout<<endl;
	}
	else
		cout<<-1<<endl;
}
int main()
{
	IOS;
	t=1;
	cin>>t;
	while(t--)
		solve();
    /******************/
	/*while(L<q[i].l) */
	/*    del(a[L++]);*/
	/*while(L>q[i].l) */
	/*    add(a[--L]);*/
	/*while(R<q[i].r) */
	/*	  add(a[++R]);*/
	/*while(R>q[i].r) */
	/*    del(a[R--]);*/
    /******************/
	QwQ;
}
posted @ 2024-06-07 22:23  wangmarui  阅读(7)  评论(0编辑  收藏  举报